"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var synth_1 = require("./tools/synth");
var relpath_1 = require("./relpath");
var Sim = /** @class */ (function () {
    function Sim(options) {
        if (options === void 0) { options = {}; }
        this.options = options;
    }
    Sim.prototype.sim = function (input, output, top) {
        this.iverilog(input, output, top);
        this.vvp(output);
    };
    Sim.prototype.iverilog = function (input, output, top) {
        if (this.options.triple) {
            var synth = new synth_1.Synth(this.options.triple);
            input.push(synth.cellsPath());
        }
        var inputs = input.map(function (input) { return "'" + input + "'"; }).join(' ');
        child_process_1.execSync("iverilog -s '" + top + "' -o '" + output + "' " + inputs);
    };
    Sim.prototype.vvp = function (input) {
        var options = '';
        if (!this.options.vpiSearchPath) {
            this.options.vpiSearchPath = [
                relpath_1.getRelPath('vvp', '../lib/ivl')
            ];
        }
        options += "-M " + this.options.vpiSearchPath.join(':');
        if (this.options.vpiModules) {
            options += this.options.vpiModules
                .map(function (m) { return "-m " + m; }).join(' ');
        }
        child_process_1.execSync("vvp " + options + " " + input);
    };
    return Sim;
}());
exports.Sim = Sim;
