"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var Pnr = /** @class */ (function () {
    function Pnr(triple) {
        this.triple = triple;
        if (Pnr.supportedFamilies.indexOf(triple.family) === -1) {
            throw new Error("Unsupported target family '" + triple.family + "'.");
        }
    }
    Pnr.prototype.pnr = function (input, output, pcf) {
        child_process_1.execSync("nextpnr-" + this.triple.family + " " +
            ("--" + this.triple.device + " ") +
            ("--package " + this.triple.package + " ") +
            ("--json '" + input + "' ") +
            ("--pcf '" + pcf + "' ") +
            ("--asc '" + output + "'"), { stdio: [0, 1, 2] });
    };
    Pnr.supportedFamilies = [
        'ice40'
    ];
    return Pnr;
}());
exports.Pnr = Pnr;
