"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var Prog = /** @class */ (function () {
    function Prog(triple) {
        this.triple = triple;
        if (Prog.supportedFamilies.indexOf(triple.family) === -1) {
            throw new Error("Unsupported target family '" + triple.family + "'.");
        }
    }
    Prog.prototype.prog = function (file, options) {
        if (options === void 0) { options = {}; }
        var strOptions = '';
        if (options.device) {
            strOptions += "-d i" +
                (":" + options.device.vendor) +
                (":" + options.device.product) +
                (":" + (options.device.serial || '0'));
        }
        if (options.ftdiInterface) {
            strOptions += "-I " + options.ftdiInterface;
        }
        if (options.offset) {
            strOptions += "-o " + options.offset;
        }
        child_process_1.execSync("iceprog " + strOptions + " '" + file + "'", { stdio: [0, 1, 2] });
    };
    Prog.supportedFamilies = ['ice40'];
    return Prog;
}());
exports.Prog = Prog;
