"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var child_process_1 = require("child_process");
var relpath_1 = require("../relpath");
var Synth = /** @class */ (function () {
    function Synth(triple) {
        this.triple = triple;
        if (Synth.supportedFamilies.indexOf(triple.family) === -1) {
            throw new Error("Unsupported target family '" + triple.family + "'.");
        }
    }
    Synth.prototype.synth = function (input, output, top) {
        var inputs = input.map(function (input) { return "'" + input + "'"; }).join(' ');
        child_process_1.execSync("yosys -p 'synth_" + this.triple.family + " " +
            ("-top " + top + " -json " + output + "' " + inputs), { stdio: [0, 1, 2] });
    };
    Synth.prototype.cellsPath = function () {
        return relpath_1.getRelPath('yosys', "../share/yosys/" + this.triple.family + "/cells_sim.v");
        //return spawnSync('yosys-config', [
        //    `--datdir/${this.triple.family}/cells_sim.v`
        //]).stdout
    };
    Synth.supportedFamilies = [
        'ecp5', 'ice40', 'intel', 'xilinx'
    ];
    return Synth;
}());
exports.Synth = Synth;
